package com.caimei.controller.admin.auth;

import com.caimei.model.ResponseJson;
import com.caimei.model.vo.FileTreeVo;
import com.caimei.service.data.DatabaseService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;

/**
 * @author zzj
 */
@Api(tags = "资料库Api")
@Slf4j
@RestController
@RequiredArgsConstructor
@RequestMapping("/database")
public class DatabaseApi {

    private final DatabaseService databaseService;

    @ApiOperation("获取当前路径下文件")
    @ApiImplicitParam(name = "fileId",value = "文件Id")
    @GetMapping("/path/file")
    public ResponseJson<FileTreeVo> getFileById(Integer fileId) {
       return databaseService.getFileById(fileId);
    }


    @ApiOperation("创建文件夹")
    @ApiImplicitParam(name = "fileId",value = "当前文件夹Id")
    @GetMapping("/path/package")
    public ResponseJson createPackage(Integer fileId,String packageName){
        return databaseService.createPackage(fileId,packageName);
    }

    @ApiOperation("下载文件夹")
    @ApiImplicitParam(name = "fileId",value = "当前文件夹Id")
    @GetMapping("/path/package/zip")
    public void downLoadPackageZip(Integer fileId,String packageName, HttpServletResponse response){
        databaseService.downLoadZip(fileId,packageName,response);
    }

    @ApiOperation("上传结果")
    @GetMapping("/oss/upload/result")
    public ResponseJson getOssUploadResult(String fileName,String ossName,String ossUrl,String fileSize,Integer parentId){
        return databaseService.getOssUploadResult(fileName,ossName,ossUrl,fileSize,parentId);
    }

    @ApiOperation("获取阿里云token")
    @GetMapping("/oss/token")
    public ResponseJson<HashMap<String,String>> ossTokenGet(){
        return databaseService.ossTokenGet();
    }
}
